'use strict';

var ScalaPayCalculate = {
    getNonGiftCertificateAmount: function(basket) {
        var BasketMgr = require('dw/order/BasketMgr'),
            Money = require('dw/value/Money');

        basket = (basket || BasketMgr.getCurrentOrNewBasket());
        // The total redemption amount of all gift certificate payment instruments in the basket.
        var giftCertTotal = new Money(0.0, basket.getCurrencyCode());

        // Gets the list of all gift certificate payment instruments
        var gcPaymentInstrs = basket.getGiftCertificatePaymentInstruments();
        var iter = gcPaymentInstrs.iterator();
        var orderPI = null;

        // Sums the total redemption amount.
        while (iter.hasNext()) {
            orderPI = iter.next();
            giftCertTotal = giftCertTotal.add(orderPI.getPaymentTransaction().getAmount());
        }

        // Gets the order total.
        var orderTotal = basket.getAdjustedMerchandizeTotalPrice(),
            shippingTotalPrice = basket.getAdjustedShippingTotalPrice();

        if (shippingTotalPrice.available) {
            orderTotal = orderTotal.add(basket.getAdjustedShippingTotalPrice());
        }

        // Calculates the amount to charge for the payment instrument.
        // This is the remaining open order total that must be paid.
        var amountOpen = orderTotal.subtract(giftCertTotal);

        // Returns the open amount to be paid.
        return amountOpen;
    }
};

module.exports = ScalaPayCalculate;