'use strict';

/*
 * Get Scalapay widget
 */
var LocalServiceRegistry = require('dw/svc/LocalServiceRegistry');

var ScalaPayHandleService = LocalServiceRegistry.createService('scalapay.payment.handle.rest', {
    createRequest: function (service, data, token) {
        service.setRequestMethod('POST');
        service.addHeader('Content-Type', 'application/json');
        service.addHeader('Authorization', 'Bearer ' + token);

        return JSON.stringify(data);
    },
    parseResponse: function (svc, client) {
        return client.text;
    }
});

var ScalaPayAuthorizeService = LocalServiceRegistry.createService('scalapay.payment.authorize.rest', {
    createRequest: function (service, data, token) {
        service.setRequestMethod('POST');
        service.addHeader('Content-Type', 'application/json');
        service.addHeader('Authorization', 'Bearer ' + token);

        return JSON.stringify(data);
    },
    parseResponse: function (svc, client) {
        return client.text;
    }
});

var ScalaPayAuthorizeDelayService = LocalServiceRegistry.createService('scalapay.payment.authorize.delay.rest', {
    createRequest: function (service, data, token) {
        service.setRequestMethod('POST');
        service.addHeader('Content-Type', 'application/json');
        service.addHeader('Authorization', 'Bearer ' + token);

        return JSON.stringify(data);
    },
    parseResponse: function (svc, client) {
        return client.text;
    }
});

module.exports = {
    ScalaPayHandleService: ScalaPayHandleService,
    ScalaPayAuthorizeService: ScalaPayAuthorizeService,
    ScalaPayAuthorizeDelayService: ScalaPayAuthorizeDelayService
};
